//+------------------------------------------------------------------+
//|                                       Support and Resistance.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Aaragorn"
#property link      "http://www.forex-tsd.com/members/aaragorn.html"
// This is an attempt to locate support and resistance and determine it's relative strength
// At maximum NumberOfBars(300); this EA is doing over 90,000 arithmetical calculations for each bar.
// It stands to reason not to run in on small timeframe charts.
// This is only looking at horizontal lines not trendlines. The goal is not simply to look at
// support and resistance as the highest highs or lowest lows but based on the actual open and close.
 
extern int NumberOfBars = 20;
#define SIZE 20  // must be set to match NumberOfBars
static int Index = 0;
static double Opens[ SIZE ] = { 0 };
static double Closes[ SIZE ] = { 0 };
static double OpenMatches[ SIZE ] = { 0 };
static double CloseMatches[ SIZE ] = { 0 };
static double TotalMatches[ SIZE ] = { 0 };
static double OpenLevels[ SIZE ] = { 0 };
static double CloseLevels[ SIZE ] = { 0 };
static double CombinedLevels[ SIZE ] = { 0 };
static double OpenBars[ SIZE ] = { 0 };
static double CloseBars[ SIZE ] = { 0 };
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----We tally the opens and closes of the Bars

   Print("Support and Resistance EA has started");
   int i = NumberOfBars;
   while(i>0)
     {
      Opens[i]  = iOpen(NULL, 0, i);
      Closes[i] = iClose(NULL, 0, i);
      i--;
     }
//We calculate the matches for each open with the other open bars in the current set +/- 1 pip counts as a match

   //this loop cycles each open bar thru the examination
   int ct=0;
   i = NumberOfBars; 
   for(ct=NumberOfBars;ct>0;ct--)   
      {
       double xt=Opens[i];
      //this loop counts matches for each bar with the other bars
       int cnt=0, match=0, t=NumberOfBars;
       for(cnt=NumberOfBars;cnt>0;cnt--)   
          {
            double tx=Opens[t];          
            if(xt==tx || xt==tx+Point || xt==tx-Point)
               {
               match++;
               }
           t--;   
          }
      //we save the results for each bar
      OpenMatches[i]=match;
      OpenLevels[i]=xt;
      OpenBars[i]=i;
      match=0;
      
      
      
      //We print the result
      Print("Bar: ",i,"  Level: ",xt,"   Open Matches: ",OpenMatches[i]);       
      i--;
      }
 
   
      
//We calculate the matches for each open with the close bars in the current set +/- 1 pip counts as a match

      
   //this loop cycles each close bar thru the examination
   int ct2=0;
   i = NumberOfBars; 
   for(ct2=NumberOfBars;ct2>0;ct2--)   
      {
       double xt2=Opens[i];
      //this loop counts matches for each bar with the other bars
       int cnt2=0, match2=0, t2=NumberOfBars;
       for(cnt2=NumberOfBars;cnt2>0;cnt2--)   
          {
            double tx2=Closes[t2];          
            if(xt2==tx2 || xt2==tx2+Point || xt2==tx2-Point)
               {
               match2++;
               }
           t2--;   
          }
      //we save the results for each bar
      CloseMatches[i]=match2;
      CloseLevels[i]=xt2;
      CloseBars[i]=i;
      match2=0;


      //We print the result
      Print("Bar: ",i,"  Level: ",xt2,"   Close Matches: ",CloseMatches[i]);       
      i--;
      }   

// We combine the matches from the opens and closes

   TotalMatches[i] = OpenMatches[i] + CloseMatches[i];
   CombinedLevels[i] = (OpenLevels[i] + CloseLevels[i])/2;



      
Print("Support and Resistance EA has finished");
//----
return(0);
}
//+------------------------------------------------------------------+